/******************************************************************************/
/* Projet.............: Pavage de plan                                        */
/* Fichier............: forme.h                                               */
/* Date de cration...: 08/07/2008                                            */
/* Auteur.............: Florian SURET                                         */
/******************************************************************************/

#ifndef _FORME_H_
#define _FORME_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* largeur/hauteur maximum d'une forme */
#define MAX 100

typedef struct _forme {
	int matrice[MAX][MAX];
	int hauteur;
	int largeur;
	char lettre;
} t_forme;

/* cration d'une forme vierge */
t_forme* creerForme(char lettre);

/* affichage d'une forme */
void afficherForme(const t_forme* forme);

/* ajout d'une ligne  la forme */
void ajouterLigne(t_forme* forme, char* ligne);

/* destruction d'une forme */
void detruireForme(t_forme* forme);

/* nombre de cases de la forme */
int nombreCases(const t_forme* forme);

/* rotation d'une forme de 90 */
void tournerForme90(t_forme* forme);

/* rotation d'une forme de 180 */
void tournerForme180(t_forme* forme);

/* quilibre gauche/droite de la forme */
int equilibreGaucheDroite(const t_forme* forme);

/* quilibre haut/bas de la forme */
int equilibreHautBas(const t_forme* forme);

#endif
