/******************************************************************************/
/* Projet.............: Pavage de plan                                        */
/* Fichier............: liste.c                                               */
/* Date de cration...: 08/07/2008                                            */
/* Auteur.............: Florian SURET                                         */
/******************************************************************************/

#include "liste.h"

/* affichage d'une liste */
void afficherListe(const t_liste* liste){
	/* tte de la liste */
	t_liste parcours = *liste;
	
	/* parcours de la liste */
	while (parcours != NULL) {
		/* affichage de la forme */
		afficherForme(parcours->forme);
		
		/* forme suivante */
		parcours = parcours->suivant;
	}
}

/* ajout d'une forme  une liste */
void ajouterForme(t_liste* liste, t_forme* forme){
	t_liste parcours = NULL;
	
	/* allocation mmoire */
	t_liste nouveau = malloc(sizeof(t_maillon));
	nouveau->forme = forme;
	
	/* ajout en premire position */
	if (*liste == NULL || nombreCases(nouveau->forme) > nombreCases((*liste)->forme)) {
		/* ajout de la forme */
		nouveau->suivant = *liste;
		*liste = nouveau;
		
	} else {
		/* tte de la liste */
		parcours = *liste;
		
		/* parcours de la liste */
		while (parcours->suivant != NULL && nombreCases(nouveau->forme) <= nombreCases(parcours->suivant->forme)) {
			/* forme suivante */
			parcours = parcours->suivant;
		}
		
		/* ajout de la forme */
		nouveau->suivant = parcours->suivant;
		parcours->suivant = nouveau;
	}
}

/* suppression d'une forme */
t_forme* supprimerForme(t_liste* liste){
	t_forme* forme;
	
	/* premire forme */
	t_liste premier = *liste;
	forme = premier->forme;
	
	/* suppression de la premire forme */
	*liste = premier->suivant;
	
	/* dsallocation du maillon */
	free(premier);
	premier = NULL;
	
	return forme;
}
