/******************************************************************************/
/* Projet.............: Pavage de plan                                        */
/* Fichier............: main.c                                                */
/* Date de cration...: 08/07/2008                                            */
/* Auteur.............: Florian SURET                                         */
/******************************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "pavage.h"

/* largeur maximale */
#define LARGEUR 500

int main(int argc, char *argv[]){
	/* liste des formes  utiliser */
	t_liste liste = NULL;
	
	/* rsultat du pavage */
	t_resultat* resultat = NULL;
	
	/* largeur relle du pavage */
	int largeur;
	
	/* paramtres d'excution */
	if (argc != 2) {
		printf("L'excution se fait de la manire suivante : Pavage_de_plan.exe largeur\n");
		exit(-1);
	}
	
	/* conversion du paramtre en entier */
	largeur = atoi(argv[1]);
	if (largeur <= 0 || largeur > LARGEUR) {
		printf("Le paramtre doit tre compris entre 1 et %d\n", LARGEUR);
		exit(-1);
	}
	
	/* lecture des donnes */
	liste = lireDonnees();
	
	/* pavage du plan */
	resultat = paverPlan(&liste, largeur);
	
	/* criture du rsultat */
	ecrireResultat(resultat);
	
	return 0;
}
