/******************************************************************************/
/* Projet.............: Pavage de plan                                        */
/* Fichier............: pavage.c                                              */
/* Date de cration...: 08/07/2008                                            */
/* Auteur.............: Florian SURET                                         */
/******************************************************************************/

#include "pavage.h"

/* taille du buffer de lecture */
#define TAILLE 128

/* lecture des donnes */
t_liste lireDonnees(){
	FILE* fichier = NULL;
	t_forme* forme = NULL;
	char ligne[TAILLE];
	char lettre;
	
	/* liste des formes  utiliser */
	t_liste liste = NULL;
	
	/* ouverture du fichier */
	if ((fichier = fopen("formes.txt", "r")) == NULL){
		printf("Erreur d'ouverture du fichier formes.txt\n");
		exit(-1);
	}
	
	lettre = 'A';
	
	/* lecture du fichier */
	while (fgets(ligne, TAILLE, fichier) != NULL) {
		/* pas de forme */
		if (forme == NULL) {
			/* crer la forme */
			forme = creerForme(lettre);
			lettre++;
		}
		
		/* saut de ligne */
		if (strcmp(ligne, "\n") == 0) {
			/* ajouter la forme  la liste */
			ajouterForme(&liste, forme);
			forme = NULL;
		} else {
			/* ajouter la ligne  la forme */
			ajouterLigne(forme, ligne);
		}
	}
	
	/* fermeture du fichier */
	fclose(fichier);
	
	return liste;
}

/* pavage du plan */
t_resultat* paverPlan(t_liste* liste, int largeur){
	t_forme* forme = NULL;
	
	/* cration du rsultat */
	t_resultat* resultat = creerResultat(largeur);
	
	/* parcours des formes */
	while (*liste != NULL) {
		/* supprimer la forme */
		forme = supprimerForme(liste);
		
		/* la forme ne rentre pas dans le plan */
		if (forme->largeur > resultat->largeur_max && forme->hauteur > resultat->largeur_max) {
			/* message d'indication */
			printf("La forme %c ne rentre pas.\n", forme->lettre);
		} else {
			/* utiliser la forme */
			utiliserForme(resultat, forme);
		}
		
		/* dtruire la forme */
		detruireForme(forme);
	}
	
	/* affichage du rsultat */
	printf("Affichage du resultat :\n");
	afficherResultat(resultat, stdout);
	
	/* nombre de lignes necssaires pour agencer les formes */
	printf("Nombre de lignes necessaires pour agencer les formes = %d.\n", resultat->hauteur);
	
	return resultat;
}

/* criture des rsultats */
void ecrireResultat(t_resultat* resultat){
	FILE* fichier = NULL;
	
	/* ouverture du fichier */
	if ((fichier = fopen("resultat.txt", "w")) == NULL) {
		printf("Erreur d'ouverture du fichier resultat.txt\n");
		exit(-1);
	}
	
	/* criture du rsultat */
	afficherResultat(resultat, fichier);
	
	/* destruction du rsultat */
	detruireResultat(resultat);
	
	/* fermeture du fichier */
	fclose(fichier);
}
