/******************************************************************************/
/* Projet.............: Pavage de plan                                        */
/* Fichier............: resultat.h                                            */
/* Date de cration...: 08/07/2008                                            */
/* Auteur.............: Florian SURET                                         */
/******************************************************************************/

#ifndef _RESULTAT_H_
#define _RESULTAT_H_

#include <stdio.h>
#include <stdlib.h>

#include "forme.h"

#define NB_FORMES 26

typedef struct _resultat {
	char** matrice;
	int hauteur;
	int largeur;
	int largeur_max;
} t_resultat;

/* cration d'un rsultat vierge */
t_resultat* creerResultat(int largeur);

/* affichage d'un rsultat */
void afficherResultat(const t_resultat* resultat, FILE* stream);

/* test si le positionnement d'une forme est possible */
int estPossible(const t_resultat* resultat, const t_forme* forme, int x, int y);

/* positionnement d'une forme */
void positionnerForme(t_resultat* resultat, const t_forme* forme, int x, int y);

/* equilibre gauche/droite du resultat */
int equilibreResultat(const t_resultat* resultat);

/* utilisation d'une forme */
void utiliserForme(t_resultat* resultat, t_forme* forme);

/* destruction d'un rsultat */
void detruireResultat(t_resultat* resultat);

#endif
